/* 
 * prof Constantin Galatan
 * O(n * k)
 */ 
#include <fstream>
#include <cstring>
#include <algorithm>
using namespace std;

ifstream fin("kds.in");
ofstream fout("kds.out");

int s[3][5001];   // s[i][j] - suma minima a unui subsir format din j elem neadiacente pana la poz i
int a[10001];
int n, k, S;

int main()
{
	fin >> n >> k;
	for (int i = 0; i < n; ++i)
	{
		fin >> a[i];
		S += a[i];
	}
	
	memset(s, 0x3f, sizeof(s));
	// Se ia a[0], deci NU se ia a[n - 1]
	s[0][0] = 0;
	s[0][1] = s[1][1] = a[0]; // SE IA a[0]
	int i0 = 2, i1 = 1, i2 = 0, x, y;
	for (int i = 2; i < n; ++i, i0++, i1++, i2++)
	{
		i0 %= 3; i1 %= 3; i2 %= 3; 
		for (int j = 1; j <= k && 2 * j <= n; ++j)
			s[i0][j] = min(s[i1][j], s[i2][j - 1] +  a[i]); // s[i][j] = min(s[i - 1][j], s[i - 2][j - 1] +  a[i])
		if ( i == n - 2 )
			x = s[i0][k];
	}
	
	// Nu se ia a[0], atunci se ia sau nu se ia a[n - 1]		
	memset(s, 0x3f, sizeof(s));
	s[0][0] = s[1][0] = 0;
	s[1][1] = a[1]; 
	i0 = 2, i1 = 1, i2 = 0;
	for (int i = 2; i < n; ++i, i0++, i1++, i2++)
	{
		i0 %= 3; i1 %= 3; i2 %= 3; 
	//	s[i0][0] = 0;
		for (int j = 1; j <= k && 2 * j <= n; ++j)
			s[i0][j] = min(s[i1][j], s[i2][j - 1] + a[i]);     // s[i][j] = min(s[i - 1][j], s[i - 2][j - 1] +  a[i])
		if ( i == n - 1 )
			y = s[i0][k];
	}
		
	fout << S - min(x, y);
	
	fout.close();
	fin.close();
}
