/*
   prof. Eugen Nodea
   Complexitate: O(Q*N*N)
*/
# include <fstream>
# include <cstring>
# include <string>
using namespace std;

ifstream f("dorel.in");
ofstream g("dorel.out");

const int NMax = 10002;
string s, x, y;
char aux[NMax];
int st[NMax], dr[NMax], maxx[32], minn[32];
short **A;

inline int palindrom(char s[], int n, int Max)
{
	int st, dr, centru;
	int k = 0, p = 0;

	for(p=0; p<=1; ++p){///pot avea un subsir pald. de lungime para sau impara
		for(centru=Max/2; centru<n-Max/2+1; ++centru){ ///alegem centrul palindromului
			st = dr = centru;   /// palindrom cu nr. elem. par
			k = -1;
			if(p == 1){         /// palindrom cu nr. elem. impar
				++dr;
				k = 0;
			}
			///incercam sa marim palindromul in stanga si dreapta
			while(s[st] == s[dr] && st>=0 && dr<n){
                k += 2;
                --st; ++dr;
			}
			if(k > Max)Max = k;
		}
	}
    return Max;
}

void preprocesare ()
{
    int k, i, j, ch, L;
    L = s.length();
    for (i=0; i<L; ++i) { //stanga
        ch = s[i] - 'a' + 1;
        k = 0;
        for (j=ch; j<=27; ++j)
            k = max(k, maxx[j]);
        st[i] = k;
        maxx[ch] = i;
    }

    for (i=L-1; i>=0; --i) { //dreapta
        ch = s[i] - 'a' + 1;
        k = L-1;
        for (j=ch; j>=1; --j)
            if (minn[j] != 0) k = min(k, minn[j]);
        dr[i] = k;
        minn[ch]=i;
    }
}
int main()
{
    int i, Q, j, p, l, m, n, LMax;

    f >> s;
    preprocesare();

    f >> Q;
    while(Q--){
        f >> p;
        p--;
        x = s;
        i = st[p]; j = dr[p];
        l = j-i+1;
        x.copy(aux, l, i);
        aux[l] = '\0';
        y = aux;
        x.erase(i, l);
        m = x.length(); n = y.length();

        A = new short * [m+2];
        for(int i=0; i<=m+1; ++i)
            A[i] = new short [n+2];

        for (i=0; i<=m; i++){
            for (j=0; j<=n; j++){
                if (i == 0 || j == 0)
                    A[i][j] = 0;
                else if (x[i-1] == y[j-1]){
                    A[i][j] = A[i-1][j-1] + 1;
                }
                else A[i][j] = 0;
            }
        }
        LMax = 0;
        for (i=1; i<=m; i++){
            for (j=1; j<=n; j++){
                if (A[i][j] > LMax){
                    int v = A[i][j];
                    y.copy(aux, v, j - v);
                    aux[v] = '\0';
                    LMax = max(LMax, palindrom(aux, v, LMax));
                }
            }
        }
        g << LMax << " ";
    }
    g << "\n";
    return 0;
}
