/*
   prof. Eugen Nodea
   Complexitate: O(Q*N*N)
*/
# include <fstream>
# include <cstring>
# include <string>
using namespace std;

ifstream f("dorel.in");
ofstream g("dorel.out");

const int NMax = 10002;
string s, x, y;
char aux[NMax];
int st[NMax], dr[NMax], maxx[32], minn[32];
short **A;

int palindrom(char t[], int n)
{
    int N = n * 2 + 1;
    char s[N];
    int z[N];

    memset(s, '.', N);
    memset(z, 0, N);
    for (int i=0; i<n; ++i) s[i*2+1] = t[i];

    int L = 0, R = 0;
    for (int i=1; i<N; ++i) {
        z[i] = (R > i) ? min(z[2*L-i], R-i) : 1;
        while (i-z[i] >= 0 && i+z[i] < N &&
               s[i-z[i]] == s[i+z[i]]) z[i]++;
        if (i+z[i] > R) L = i, R = i+z[i];
    }

    int maxx = 0, p = 0;
    for (int i=1; i<N; ++i)
        if (z[i] > maxx)
            maxx = z[p = i];

    return maxx - 1;
}

void preprocesare ()
{
    int k, i, j, ch, L;
    L = s.length();
    for (i=0; i<L; ++i) { //stanga
        ch = s[i] - 'a' + 1;
        k = 0;
        for (j=ch; j<=27; ++j)
            k = max(k, maxx[j]);
        st[i] = k;
        maxx[ch] = i;
    }

    for (i=L-1; i>=0; --i) { //dreapta
        ch = s[i] - 'a' + 1;
        k = L-1;
        for (j=ch; j>=1; --j)
            if (minn[j] != 0) k = min(k, minn[j]);
        dr[i] = k;
        minn[ch]=i;
    }
}
int main()
{
    int i, Q, j, p, l, m, n, LMax;

    f >> s;
    preprocesare();

    f >> Q;
    while(Q--){
        f >> p;
        p--;
        x = s;
        i = st[p]; j = dr[p];
        l = j-i+1;
        x.copy(aux, l, i);
        aux[l] = '\0';
        y = aux;
        x.erase(i, l);

        m = x.length(); n = y.length();

        A = new short * [m+2];
        for(int i=0; i<=m+1; ++i)
            A[i] = new short [n+2];

        for (i=0; i<=m; i++){
            for (j=0; j<=n; j++){
                if (i == 0 || j == 0)
                    A[i][j] = 0;
                else if (x[i-1] == y[j-1]){
                    A[i][j] = A[i-1][j-1] + 1;
                }
                else A[i][j] = 0;
            }
        }
        LMax = 0;
        for (i=1; i<=m; i++){
            for (j=1; j<=n; j++){
                if (A[i][j] > LMax){
                    int v = A[i][j];
                    y.copy(aux, v, j - v);
                    aux[v] = '\0';
                    LMax = max(LMax, palindrom(aux, v));
                }
            }
        }
        g << LMax << " ";
    }
    g << "\n";
    return 0;
}
