///Complexitate O(N^2)
///Mihail-Cosmin Pit-Rada
#include <fstream>
#include <cstring>
using namespace std;

const int 	MAX_SIZE 	= 1009;
const int 	MOD 		= 1000000007;
char 		A[MAX_SIZE][MAX_SIZE];
int 		dp[MAX_SIZE][MAX_SIZE][2];

int main()
{
	ifstream 	f("trasee.in");
	ofstream 	g("trasee.out");
	int 		M, N, a, b;
	long long ans;

	f >> N >> M;
	memset(A, 1, sizeof(A));
	for (int i = 0; i < M; i++)
	{
		f >> a >> b;
		A[a-1][b-1] = A[b-1][a-1] = 0;
	}

	memset(dp, sizeof(dp), 0);
	dp[0][0][0] = dp[0][0][1] = 1;
	dp[0][N - 1][0] = 0;
	dp[0][N - 1][1] = A[0][N - 1];
	dp[1][0][0] 	= A[0][1];
	dp[1][0][1]     = 0;
	for (int k = 2; k < N; k++)
		for (int i = 0; i <= k; i++)
		{
			int j 		= (N - (k - i)) % N;
			int prevj 	= (j + 1) % N;

			if (i != 0) dp[i][j][0] = (A[i - 1][i] * dp[i - 1][j][0] + A[j][i] * dp[i - 1][j][1]) % MOD;
			if (j != 0) dp[i][j][1] = (A[prevj][j] * dp[i][prevj][1] + A[i][j] * dp[i][prevj][0]) % MOD;
		}

	ans = 0;
	for (int i = 0; i < N; i++)
	{
		int j = (i + 2) % N;
		if (i != 0) 	ans = (ans + dp[i][j][0]) % MOD;
		if (j != 0) 	ans = (ans + dp[i][j][1]) % MOD;
	}

	g << ans << endl;

	return 0;
}

